//////////////////////////////////////////
//
// Created by XueHeng
// http://www.verypdf.com
// support@verypdf.com 
//
//////////////////////////////////////////

#include <stdio.h>
#include <aconf.h>
#include "parseargs.h"
#include "gmem.h"
#include "GString.h"
#include "GlobalParams.h"
#include "Object.h"
#include "PDFDoc.h"
#include "SplashBitmap.h"
#include "Splash.h"
#include "SplashOutputDev.h"
#include "config.h"
#include "TextOutputDev.h"
#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdio.h>
#include <io.h>
#include <string.h>
#include <stdlib.h>
#include <direct.h>
#include <time.h>
#include <string>
using namespace std;

BOOL CreatePieceHTMLFiles(PDFDoc *doc, LPCTSTR lpHtmlFile, int firstpg, int lastpg);
int WriteToHTMLByVeryPDF(PDFDoc *doc,LPCTSTR lpOutHTML, int page, SplashBitmap* lpBitmap, TextOutputDev *lpTextFormater,
					  BOOL bDeletePictures, int pages, int curPage);
void ReplaceHTMLCode(char *lpText, int nLen, string& strOutText);
int PDF2TXT_main(int argc, char *argv[]);

static int firstPage = 1;
static int lastPage = 0;
int resolution = 100;
static GBool mono = gFalse;
static GBool gray = gFalse;
static char enableT1libStr[16] = "";
static char enableFreeTypeStr[16] = "";
static char antialiasStr[16] = "";
static char ownerPassword[33] = "";
static char userPassword[33] = "";
static GBool quiet = gTrue;
static char cfgFileName[256] = "";
static GBool printVersion = gFalse;
static GBool printHelp = gFalse;
int g_bRegistered = FALSE;
int g_nJPEGQuality = 95;
int g_nOutImgFormat = 1;
int g_nOneHTMLFile = 0;
int g_nOneWord = 0;
int g_nNoSEO = 0;
int g_nNoImage = 0;
int g_nNoTxtIdx = 0;
int g_nNoTextInHTMLBody = 0;
int g_nNoTextInHTMLMeta = 0;
char g_szHomeURL[1024] = {0};
int g_nYOffset = 0;
extern POINT g_ptLastPage;
int g_nNoUTF8Flag = FALSE;

static ArgDesc argDesc[] = {
	{"-f",			argInt,      &firstPage,		0,		"first page to convert"},
	{"-l",			argInt,      &lastPage,			0,		"last page to convert"},
	{"-r",			argInt,      &resolution,		0,		"resolution, in DPI (default is 100)"},
	{"-quality",	argInt,      &g_nJPEGQuality,   0,		"set quality for JPEG file, default is 95"},
	{"-imgformat",	argInt,      &g_nOutImgFormat,  0,		"0 is JPEG, 1 is PNG, 2 is GIF"},
	{"-opw",		argString,   ownerPassword,  sizeof(ownerPassword),	"owner password (for encrypted PDF file)"},
	{"-upw",		argString,   userPassword,   sizeof(userPassword),	"user password (for encrypted PDF file)"},
	{"-onehtm",     argFlag,     &g_nOneHTMLFile,   0,		"generate in one continuous html page"},
	{"-oneword",    argFlag,     &g_nOneWord,       0,		"create accurate HTML files"},
	{"-noimg",      argFlag,     &g_nNoImage,       0,		"remove images from HTML files"},
	{"-notxtidx",   argFlag,     &g_nNoTxtIdx,      0,		"remove text index file from HTML files"},
	{"-notextinbody",argFlag,    &g_nNoTextInHTMLBody,0,	"remove text from HTML's body"},
	{"-notextinmeta",argFlag,    &g_nNoTextInHTMLMeta,0,	"remove text from HTML's meta"},
	{"-noseo",      argFlag,     &g_nNoSEO,         0,		"don't optimize HTML files for search engines"},
	{"-homeurl",	argString,   g_szHomeURL, sizeof(g_szHomeURL),	"add a home URL into the left index page"},
	{"-yoffset",    argInt,      &g_nYOffset,		0,		"set Y offset for HTML page contents"},
	{"-noutf8",     argFlag,     &g_nNoUTF8Flag,    0,		"remove UTF8 header to compatible with Firefox"},
	{NULL}
};

int ConvertPDF2Text(LPCTSTR lpPDFFile, LPCTSTR lpHTMLFile, char *lpszOutFile)
{
	if(g_nOneHTMLFile == 1)
		return -1;
	if(g_nNoSEO)
		return -1;
	if(lpHTMLFile == NULL || lpHTMLFile[0] == 0)
		return -1;
	if(GetFileAttributes(lpPDFFile) == -1)
		return -2;
	char szHTMLRoot[MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char FileName[_MAX_PATH];
	char ext[_MAX_EXT];
	_splitpath(lpHTMLFile, drive, dir, FileName, ext );
	_makepath(szHTMLRoot, drive, dir, FileName, "");
	_mkdir(szHTMLRoot);
	if(szHTMLRoot[strlen(szHTMLRoot)-1] != '\\')
		strcat(szHTMLRoot, "\\");
	string strTextFile = szHTMLRoot;
	strTextFile += "txtidx.htm";

#define MAX_ARGC 100
	char *argv[MAX_ARGC];
	char *argv2[MAX_ARGC];
	int argc = 0;
	for(int i = 0; i < MAX_ARGC; i++)
	{
		argv[i] = (char*)malloc(MAX_PATH);
		memset(argv[i], 0, MAX_PATH);
		argv2[i] = argv[i];
	}
	strcpy(argv[argc++], "verypdf.exe");
	strcpy(argv[argc++], "-layout");
	strcpy(argv[argc++], "-htmlmeta");
	strcpy(argv[argc++], lpPDFFile);
	strcpy(argv[argc++], strTextFile.c_str());
	int exitCode = PDF2TXT_main(argc,argv);
	for(i = 0; i < MAX_ARGC; i++)
	{
		if(argv2[i])
			free(argv2[i]);
	}
	if(lpszOutFile)
		strcpy(lpszOutFile, strTextFile.c_str());
	return exitCode;
}
int main(int argc, char *argv[])
{
	PDFDoc *doc;
	GString *fileName;
	char *lpDOCFile;
	GString *ownerPW, *userPW;
	SplashColor paperColor;
	SplashOutputDev *splashOut;
	GBool ok;
	int exitCode;
	int pg;
	
	exitCode = 99;

	// parse args
	ok = parseArgs(argDesc, &argc, argv);
	if (mono && gray)
	{
		ok = gFalse;
	}
	if (!ok || argc != 3 || printVersion || printHelp)
	{
		printf("PDF to HTML Converter Command Line v3.2\n");
		printf("Web: http://www.verypdf.com\n");
		printf("Web: http://www.verydoc.com\n");
		printf("Email: support@verypdf.com\n");
		printf("Release Date: "__DATE__"\n");
		printf("-------------------------------------------------------\n");
		printf("Description:\n");
		printf("  Convert Acrobat PDF files to HTML files.\n");
		printUsage("pdf2html", "<PDF-file> <HTML-file>", argDesc);
		printf("Examples:\n");
		printf("  pdf2html.exe C:\\in.pdf C:\\out.htm\n");
		printf("  pdf2html.exe -r 150 C:\\in.pdf C:\\out.htm\n");
		printf("  pdf2html.exe -imgformat 1 C:\\in.pdf C:\\out.htm\n");
		printf("  pdf2html.exe -noimg C:\\in.pdf C:\\out.htm\n");
		printf("  pdf2html.exe -onehtm C:\\in.pdf C:\\out.htm\n");
		printf("  pdf2html.exe -oneword C:\\in.pdf C:\\out.htm\n");
		printf("  pdf2html.exe -homeurl \"http://www.verypdf.com\" C:\\in.pdf C:\\out.htm\n");
		printf("  pdf2html.exe -yoffset 20 C:\\in.pdf C:\\out.htm\n");
		printf("  pdf2html.exe -notextinbody -notextinmeta C:\\in.pdf C:\\out.htm\n");
		goto err0;
	}

	if(g_nYOffset)
	{
		g_ptLastPage.y = g_nYOffset;
	}
	if(g_nNoTxtIdx == 0)
	{
		char szTxtIdxFile[MAX_PATH] = {0};
		ConvertPDF2Text(argv[1], argv[2], szTxtIdxFile);
	}
	fileName = new GString(argv[1]);
	lpDOCFile = argv[2];
	
	// read config file
	globalParams = new GlobalParams(cfgFileName);

	globalParams->setTextEncoding("UTF-8");
	if (enableT1libStr[0]) {
		if (!globalParams->setEnableT1lib(enableT1libStr)) {
			fprintf(stderr, "Bad '-t1lib' value on command line\n");
		}
	}
	if (enableFreeTypeStr[0]) {
		if (!globalParams->setEnableFreeType(enableFreeTypeStr)) {
			fprintf(stderr, "Bad '-freetype' value on command line\n");
		}
	}
	if (antialiasStr[0]) {
		if (!globalParams->setAntialias(antialiasStr)) {
			fprintf(stderr, "Bad '-aa' value on command line\n");
		}
	}
	if (quiet) {
		globalParams->setErrQuiet(quiet);
	}
	
	// open PDF file
	if (ownerPassword[0]) {
		ownerPW = new GString(ownerPassword);
	} else {
		ownerPW = NULL;
	}
	if (userPassword[0]) {
		userPW = new GString(userPassword);
	} else {
		userPW = NULL;
	}
	doc = new PDFDoc(fileName, ownerPW, userPW);
	if (userPW) {
		delete userPW;
	}
	if (ownerPW) {
		delete ownerPW;
	}
	if (!doc->isOk()) {
		exitCode = 1;
		goto err1;
	}
	
	// get page range
	if (firstPage < 1)
		firstPage = 1;
	if (lastPage < 1 || lastPage > doc->getNumPages())
		lastPage = doc->getNumPages();
	
	// write PPM files
	if (mono) {
		paperColor[0] = 1;
		splashOut = new SplashOutputDev(splashModeMono1, 1, gFalse, paperColor);
	} else if (gray) {
		paperColor[0] = 0xff;
		splashOut = new SplashOutputDev(splashModeMono8, 1, gFalse, paperColor);
	} else {
		paperColor[0] = paperColor[1] = paperColor[2] = 0xff;
		splashOut = new SplashOutputDev(splashModeBGR8, 1, gFalse, paperColor);
	}
	CreatePieceHTMLFiles(doc, lpDOCFile, firstPage, lastPage);
	splashOut->startDoc(doc->getXRef());
	for (pg = firstPage; pg <= lastPage; ++pg)
	{
		printf("Processing page %d of %d...\n", pg-firstPage+1, lastPage-firstPage+1);
		doc->displayPage(splashOut, pg, resolution, resolution, 0, gFalse, gTrue, gFalse);
		SplashBitmap* lpBitmap = splashOut->getBitmap();

		TextOutputDev *textOut;
		if ((textOut = new TextOutputDev(NULL, gTrue, gFalse, gFalse)))
		{
			doc->displayPage(textOut, pg, resolution, resolution, 0, gFalse, gTrue, gFalse);
			WriteToHTMLByVeryPDF(doc,lpDOCFile, pg-firstPage+1, lpBitmap, textOut, g_nNoImage, lastPage-firstPage+1,
				pg);
			delete textOut;
		}
	}
	delete splashOut;
	
	exitCode = 0;
	
	// clean up
err1:
	delete doc;
	delete globalParams;
err0:
	
	// check for memory leaks
	Object::memCheck(stderr);
	gMemReport(stderr);
	return exitCode;
}
