//////////////////////////////////////////
//
// Created by XueHeng
// http://www.verypdf.com
// support@verypdf.com 
//
//////////////////////////////////////////

#include <stdio.h>
#include <io.h>
#include <string.h>
#include <stdlib.h>
#include <direct.h>
#include <afxwin.h>
#include <string>
#include <vector>
using namespace std;
#include "parseargs.h"
#include "gmem.h"
#include "GString.h"
#include "GlobalParams.h"
#include "Object.h"
#include "PDFDoc.h"
#include "SplashBitmap.h"
#include "Splash.h"
#include "SplashOutputDev.h"
#include "config.h"
#include "TextOutputDev.h"
#include "gmem.h"
#include "GString.h"
#include "GList.h"
#include "config.h"
#include "Error.h"
#include "GlobalParams.h"
#include "UnicodeMap.h"
#include "UnicodeTypeTable.h"
#include "GfxState.h"
#include "Link.h"
#include "TextOutputDev.h"
#include "gfile.h"
#include <string>
using namespace std;

extern int g_nJPEGQuality;
extern int g_nOneHTMLFile;
extern int g_nOneWord;
extern int g_nNoSEO;
extern int g_nNoTextInHTMLBody;
extern int g_nNoTextInHTMLMeta;
extern int resolution;
extern int g_nNoUTF8Flag;
extern char g_szHomeURL[1024];
POINT g_ptLastPage = {0,0};
char *doAction(PDFDoc *doc, int page, LinkAction *action, char *lpszCommand);
char *memstr(char *buf, int len, char *sub);

typedef struct tagVPLOGFONTA
{
    LONG      lfHeight;
    LONG      lfWidth;
    LONG      lfEscapement;
    LONG      lfOrientation;
    LONG      lfWeight;
    BYTE      lfItalic;
    BYTE      lfUnderline;
    BYTE      lfStrikeOut;
    BYTE      lfCharSet;
    BYTE      lfOutPrecision;
    BYTE      lfClipPrecision;
    BYTE      lfQuality;
    BYTE      lfPitchAndFamily;
    CHAR      lfFaceName[1024];
} VPLOGFONT;
typedef struct SFONTITEMtag{
	VPLOGFONT font;
	BYTE rColor;
	BYTE gColor;
	BYTE bColor;
}SFONTITEM;

vector<SFONTITEM> g_aryHTMLFonts;

char *memstr(char *buf, int len, char *sub)
{
	int l = strlen(sub);
	char *p = buf;
	char *pEnd = buf+len-l;
	while(p <= pEnd)
	{
		if( !memcmp(p, sub, l) )
			return p;
		p++;
	}
	return NULL;
}

void ReplaceHTMLCode(char *lpText, int nLen, string& strOutText)
{
	if(lpText == NULL || nLen <= 0)
		return;
	char *lpTextEnd = lpText+nLen;
	while(lpText < lpTextEnd)
	{
		switch(*lpText)
		{
		case -67://0xBD = '1/2' character
			strOutText += "&frac12;";
			break;
		case 146:
			strOutText += "'";
			break;
		case 149:
			strOutText += "&#8226;";
			break;
		case 153:
			strOutText += "&#8482;";
			break;
		case '<':
			strOutText += "&lt;";
			break;
		case '>':
			strOutText += "&gt;";
			break;
		case ' ':
			strOutText += " ";
			break;
		case '&':
			strOutText += "&amp;";
			break;
		case '"':
			strOutText += "&quot;";
			break;
		case 0x0C:
			strOutText += "<p style=\"page-break-before: always\">\n";
			break;
		default:
			strOutText += *lpText;
		}
		lpText++;
	}
}
LPBYTE LoadFileIntoMemory(LPCSTR lpFileName,int& nLength)
{
	LPBYTE data = NULL;
	size_t size;
	FILE *fp;
	fp = fopen(lpFileName, "rb");
	if (fp == NULL)
		return NULL;
	fseek(fp, 0, SEEK_END);
	size = ftell(fp);
	data = (unsigned char *)malloc(size);
	fseek(fp, 0, SEEK_SET);
	fread(data, 1, size, fp);
	fclose(fp);
	nLength = size;
	return data;
}
LPBYTE ReadHTMLInfo(int& nHTMLInfLength, BOOL& bHasTitle)
{
	bHasTitle = FALSE;
	nHTMLInfLength = 0;
	char szEXEPath[1024];
	GetModuleFileName(NULL,szEXEPath,sizeof(szEXEPath));
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	_splitpath(szEXEPath, drive, dir, fname, ext );
	_makepath(szEXEPath, drive, dir,"htmlinf",".txt");
	if(GetFileAttributes(szEXEPath) == -1)
		return NULL;
	LPBYTE lpHTMLInfText = LoadFileIntoMemory(szEXEPath, nHTMLInfLength);
	if(lpHTMLInfText == NULL || nHTMLInfLength <= 0)
		return NULL;
	char *lpTitleBegin = NULL;
	char *lpTitleEnd = NULL;
	if(lpHTMLInfText != NULL && nHTMLInfLength > 0)
	{
		lpTitleBegin = memstr((char*)lpHTMLInfText, nHTMLInfLength, "<title>");
		if(lpTitleBegin == NULL)
			lpTitleBegin = memstr((char*)lpHTMLInfText, nHTMLInfLength, "<TITLE>");
		lpTitleEnd = memstr((char*)lpHTMLInfText, nHTMLInfLength, "</title>");
		if(lpTitleEnd == NULL)
			lpTitleEnd = memstr((char*)lpHTMLInfText, nHTMLInfLength, "</TITLE>");
	}
	if(lpTitleBegin && lpTitleEnd)
		bHasTitle = TRUE;
	else
		bHasTitle = FALSE;
	return lpHTMLInfText;
}
void WriteMainHtm(string CssPathName,string MainHtmName,int firstpage, int lastpage)
{
	string szFirstpage;
	char szTmp[MAX_PATH];
	sprintf(szTmp, "pg_%04d.htm",1);
	szFirstpage = szTmp;

	string strIndexPage = "pg_index.htm";
	string strNavPage = "pg_nav.htm";
	string strFirstPage = szFirstpage;

	char *lpKey = strrchr(MainHtmName.c_str(),'\\');
	if(lpKey)
		MainHtmName.erase(MainHtmName.begin(),lpKey+1);

	char szHTMLText[2048];
	sprintf(szHTMLText, "<script TYPE=\"text/javascript\">\n\
var firstpage = %d;\n\
var lastpage = %d;\n\
var the_timeout = setTimeout(\"lbottom.location.reload();\",3000);\n\
</script></head>\n\
<frameset rows=\"30,*\" framespacing=\"1\" border=\"0\" frameborder=\"0\">\n\
    <frame name=\"ltop\" scrolling=\"no\" target=\"lbottom\" src=\"%s\">\n\
    <frameset name = \"leftpane\" cols=\"150,*\">\n\
	<frame name=\"lbottom\" target=\"contents\" src=\"%s\">\n\
	<frame name=\"contents\" src=\"%s\">\n\
    </frameset>\n\
\
  <noframes>\n\
  <body>\n\
  	<p>This page uses frames, but your browser doesn't support them.</p>\n\
  </body>\n\
  </noframes>\n\
</frameset></html>\n",
	1,lastpage-firstpage+1, strNavPage.c_str(),strIndexPage.c_str(),strFirstPage.c_str());

	string strFileName = CssPathName + "index.htm";
	FILE *stream;
	stream = fopen(strFileName.c_str(), "w" );
	if(stream)
	{
		fputs("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n<!-- saved from url=(0052)http://www.verypdf.com/ -->\n",stream);
		fputs("<html><head>\n",stream);

		int nHTMLInfLength = 0;
		BOOL bHasTitle = FALSE;
		LPBYTE lpHTMLInfText = ReadHTMLInfo(nHTMLInfLength,bHasTitle);
		if(lpHTMLInfText != NULL && nHTMLInfLength > 0)
			fwrite(lpHTMLInfText, 1, nHTMLInfLength, stream);
		if(!bHasTitle)
		{
			fprintf(stream,"%s","<title>");
			fprintf(stream,"%s",MainHtmName.c_str());
			fprintf(stream,"%s","</title>\n");
		}
		if(lpHTMLInfText)
			free(lpHTMLInfText);
		lpHTMLInfText = NULL;
		fputs("\n",stream);
		fputs(szHTMLText,stream);
		fclose(stream);
	}
}
void WriteIndexHtm(string CssPathName,string MainHtmName,int firstpage,int lastpage)
{
	string m_strHomepageURL = g_szHomeURL;
	if(m_strHomepageURL.size() == 0)
		return;
	CString strBookmarkFileName = CssPathName.c_str();
	strBookmarkFileName += "\\bookmark.htm";
	string m_strHomepageURL2;
	m_strHomepageURL2 = "<html><body><table>\n";
	if(GetFileAttributes(strBookmarkFileName) != -1)
	{
		m_strHomepageURL2 += "<tr><td><img src=\"pg_page.gif\"><a href=\"";
		m_strHomepageURL2 += "bookmark.htm";
		m_strHomepageURL2 += "\"target=\"_top\">bookmark</a></td></tr>\n";
	}
	m_strHomepageURL2 += "<tr><td><img src=\"pg_page.gif\"><a href=\"";
	m_strHomepageURL2 += m_strHomepageURL;
	m_strHomepageURL2 += "\"target=\"_top\">Home</a></td></tr>\n";
	m_strHomepageURL2 += "</table></body></html>";

	CssPathName += "\\";
	string strFileName = CssPathName + "pg_index.htm";
	FILE *stream = fopen(strFileName.c_str(), "a" );
	if(stream)
	{
		fputs("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n<!-- saved from url=(0052)http://www.verypdf.com/ -->\n",stream);
		fputs(m_strHomepageURL2.c_str(),stream);
		fclose(stream);
	}
}
extern char *getLine(char *buf, int size, FILE *f);
struct SPAGENODE{
	int level;
	CString bookmarkname;
	int pageno;
};
int getBookmark(XRef* xref, Catalog *lpCatalog, char* szFileName,int size);
int ReadBookmark(PDFDoc *doc, vector<SPAGENODE>& m_aryBookmark)
{
	XRef* xref = doc->getXRef();
	Catalog *lpCatalog = doc->getCatalog();

	char szFileName[MAX_PATH] = {0};
	if(getBookmark(xref, lpCatalog, szFileName,MAX_PATH) != gTrue)
		return 0;

	FILE *fBookmarkFile;
	if((fBookmarkFile = fopen(szFileName,"r")) != NULL)
	{
		int nestDepth = 0;
		int m_nNodeList = -1;
		CString m_strLine;
		char textline[4096];
		while(fgets(textline,4096,fBookmarkFile))
		{
			m_strLine = textline;
			m_strLine.Remove('\r');
			m_strLine.Remove('\n');
			int m_nTabCount = 0;//Tab
			int length = m_strLine.GetLength();
			if(length <= 0)
				continue;
			char *splitStr = "<>,";
			int i;// = m_strLine.Find(splitStr,0);
			const char *ppp1 = LPCTSTR(m_strLine);
			const char *ppp = strstr(ppp1,splitStr);
			if(ppp == NULL)
				i = -1;
			else
				i = ppp - ppp1;
			CString m_strText;//ǩ
			if(i == -1)
				m_strText = m_strLine;
			else
				m_strText = m_strLine.Left(i);
			m_strText.TrimLeft('\t');
			CString m_strPageNO = "1";
			if(i == -1)
			{
			}
			else
			{
				int first = i+strlen(splitStr);
				for(i = first; i < length; i++)
					if(m_strLine[i] == ',')
						break;
					if(i-first > 0)
						m_strPageNO = m_strLine.Mid(first,i-first);
			}
			while(m_strLine[m_nTabCount] == '\t')
				m_nTabCount++;
			//if(m_strText.GetLength() > 0)
			{
				//Ŀ¼
				//m_nNodeList++;
				int pageno = atoi(m_strPageNO);
				SPAGENODE m_nPageNode;
				m_nPageNode.bookmarkname = m_strText;
				m_nPageNode.level = m_nTabCount;
				m_nPageNode.pageno = pageno;
				m_nPageNode.bookmarkname.Replace("\"","&quot;");
				m_nPageNode.bookmarkname.Replace("<","&lt;");
				m_nPageNode.bookmarkname.Replace(">","&gt;");
				m_aryBookmark.push_back(m_nPageNode);
			}
		}
		fclose(fBookmarkFile);
	}
	return m_aryBookmark.size();
}
void WriteBmarkHtm(PDFDoc *doc, CString CssPathName,CString MainHtmName,int firstpage,int lastpage)
{
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_PATH];
	char ext[_MAX_EXT];
	_splitpath(LPCTSTR(MainHtmName), drive, dir, fname, ext );

	CString StrText;
	StrText.Format("root0 = gFld(\"%s\", \"\")\n",fname);

	CString strNewBookmarkIndex;

	vector<SPAGENODE> m_aryBookmark;
	if(ReadBookmark(doc, m_aryBookmark) > 0)
	{
		int nsize = m_aryBookmark.size();
		for(int i = 0; i < nsize; i++)
		{
			if((i+1 < nsize) && (m_aryBookmark[i].level < m_aryBookmark[i+1].level))
			{
				CString szNode;
				szNode.Format("root%d = insFld(root%d, gFld(\"%s\", \"%d\"))\n",
					m_aryBookmark[i].level+1,m_aryBookmark[i].level,
					LPCTSTR(m_aryBookmark[i].bookmarkname),
					m_aryBookmark[i].pageno-firstpage+1>0?m_aryBookmark[i].pageno-firstpage+1:0);
				StrText += szNode;
			}
			else
			{
				CString szNode;
				szNode.Format("insDoc(root%d, gLnk(2,\"%s\", \"%d\"))\n",
					m_aryBookmark[i].level,
					LPCTSTR(m_aryBookmark[i].bookmarkname),
					m_aryBookmark[i].pageno-firstpage+1>0?m_aryBookmark[i].pageno-firstpage+1:0);
				StrText += szNode;
			}
		}
		//Create a new HTML file for index purpose
		nsize = m_aryBookmark.size();
		for(i = 0; i < nsize; i++)
		{
			for(int level = 0; level < m_aryBookmark[i].level; level++)
			{
				strNewBookmarkIndex += "&nbsp;&nbsp;";
			}
			int page = m_aryBookmark[i].pageno-firstpage+1>0?m_aryBookmark[i].pageno-firstpage+1:0;
			CString szNode;
			szNode.Format("<a href=\"pg_%04d.htm\">%s</a><br>\n",
				page, LPCTSTR(m_aryBookmark[i].bookmarkname));
			strNewBookmarkIndex += szNode;
		}
	}
	else
	{
		StrText += "root0 = gFld(\"no bookmarks\", \"\")\n";
	}

/////////////////////////

/////////////////////////
	StrText += "</script><script>initializeDocument()</script></head>\n\
<body bgcolor=white  style=\"border-right: 2 solid #CCCCCC\">\n\
</body>\n\
</html>";

	FILE *stream;
	stream = fopen(CssPathName+"\\pg_bmark.htm", "a" );//ļ
	if(stream)
	{
		fprintf(stream,StrText);
		fclose(stream);
	}
	
	CString strFileName = CssPathName + "\\bookmark.htm";
	DeleteFile(strFileName);
	if(strNewBookmarkIndex.GetLength() > 0)
	{
		stream = fopen(strFileName, "wb" );//ļ
		if(stream)
		{
			fputs("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n<!-- saved from url=(0052)http://www.verypdf.com/ -->\n",stream);
			fputs("<html><head>\n",stream);
			
			int nHTMLInfLength = 0;
			BOOL bHasTitle = FALSE;
			LPBYTE lpHTMLInfText = ReadHTMLInfo(nHTMLInfLength,bHasTitle);
			if(lpHTMLInfText != NULL && nHTMLInfLength > 0)
				fwrite(lpHTMLInfText, 1, nHTMLInfLength, stream);
			if(!bHasTitle)
			{
				fprintf(stream,"%s","<title>");
				fprintf(stream,"%s",MainHtmName);
				fprintf(stream,"%s","</title>\n");
			}
			if(lpHTMLInfText)
				free(lpHTMLInfText);
			lpHTMLInfText = NULL;
			fputs("\n",stream);
			fputs("</head><body>\n",stream);
			fputs("<b><font size=\"5\" face=\"Verdana\"><a href=\"index.htm\">Home</a></font></b><br>\n",stream);
			fputs(strNewBookmarkIndex,stream);
			fputs("</body></html>\n",stream);
			fclose(stream);
		}
	}
}
BOOL CreatePieceHTMLFiles(PDFDoc *doc,LPCTSTR lpHtmlFile, int firstpg, int lastpg)
{
	char szHTMLRoot[MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char FileName[_MAX_PATH];
	char ext[_MAX_EXT];
	_splitpath(lpHtmlFile, drive, dir, FileName, ext );
	_makepath(szHTMLRoot, drive, dir, FileName, "");
	_mkdir(szHTMLRoot);
	if(g_nOneHTMLFile == 1)
		return TRUE;
	if(szHTMLRoot[strlen(szHTMLRoot)-1] != '\\')
		strcat(szHTMLRoot, "\\");

	char szCommandLine[1024];
	sprintf(szCommandLine, "cmd /C del /q \"%s*.*\"", szHTMLRoot);

	{
		char srcfilesdirectory[MAX_PATH];
		char srcgifname[MAX_PATH];
		char srchtmlname[MAX_PATH];
		char fname[_MAX_PATH];
		
		GetModuleFileName(NULL,srcfilesdirectory,MAX_PATH);
		_splitpath(srcfilesdirectory, drive, dir, fname, ext );
		_makepath(srcgifname, drive, dir,"pg_*.gif", "" );
		_makepath(srchtmlname, drive, dir,"pg_*.htm", "" );
		sprintf(szCommandLine, "cmd /C copy /y \"%s\" \"%s\"", srcgifname, szHTMLRoot);
		system(szCommandLine);
		sprintf(szCommandLine, "cmd /C copy /y \"%s\" \"%s\"", srchtmlname, szHTMLRoot);
		system(szCommandLine);
	}
	WriteMainHtm(szHTMLRoot,lpHtmlFile,firstpg,lastpg);
	WriteBmarkHtm(doc,szHTMLRoot,lpHtmlFile,firstpg,lastpg);
	WriteIndexHtm(szHTMLRoot,lpHtmlFile,firstpg,lastpg);
	return TRUE;
}

void ConvertPDFFontToWinFont(char *lpFont, int nSize)
{
	if(lpFont == NULL || lpFont[0] == 0)
		return;
	char szEXEPath[1024];
	GetModuleFileName(NULL,szEXEPath,sizeof(szEXEPath));
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	_splitpath(szEXEPath, drive, dir, fname, ext );
	_makepath(szEXEPath, drive, dir,"winfont",".ini");

	char szMappedFont[200] = {0};
	int nRet2 = GetPrivateProfileString("PDF2Win", lpFont, NULL, szMappedFont, sizeof(szMappedFont), szEXEPath);
	if(nRet2 > 0)
		strcpy(lpFont, szMappedFont);
	else
	{
		char szDefaultFont[200] = {0};
		GetPrivateProfileString("PDF2Win", "defaultfont", NULL, szDefaultFont, sizeof(szDefaultFont), szEXEPath);
	}
}
int FindFont(vector<SFONTITEM>& aryFonts, SFONTITEM& item)
{
	for(int i = 0; i < aryFonts.size(); i++)
	{
		if(memcmp(&aryFonts[i], &item, sizeof(SFONTITEM)) == 0)
			return i;
	}
	return -1;
}
int CompareWordAttributes(TextWord* word1,TextWord* word2)
{
	if(word1 == NULL || word2 == NULL)
		return -1;
	if(word1->fontSize != word2->fontSize)
		return 1;
	if(word1->font->isBold() != word2->font->isBold())
		return 2;
	if(word1->font->isItalic() != word2->font->isItalic())
		return 3;
	LPCTSTR lpFontName1 = word1->getFontName()?word1->getFontName()->getCString():"Arial";
	LPCTSTR lpFontName2 = word2->getFontName()?word2->getFontName()->getCString():"Arial";
	if(strcmp(lpFontName1, lpFontName2) != 0)
		return 4;
	double r, g, b;
	word1->getColor(&r,&g,&b);
	COLORREF clColor1 = RGB(r*255,g*255,b*255);
	word2->getColor(&r,&g,&b);
	COLORREF clColor2 = RGB(r*255,g*255,b*255);
	if(clColor1 != clColor2)
		return 5;
	return 0;
}
BOOL ConvertTextBlocks(FILE *file, vector<SFONTITEM>& aryFonts, TextOutputDev *lpTextFormater,
					   BOOL bCollectFonts, Links *lpLinks, PDFDoc* doc, int page, int curPage)
{
	if(file == NULL)
		return FALSE;
	TextFlow* flow;
	TextBlock* blk;
	TextLine* line;
	TextWord* word0;

	UnicodeMap *uMap = globalParams->getTextEncoding();
	for (flow = lpTextFormater->text->flows; flow; flow = flow->next)
	{
		for (blk = flow->blocks; blk; blk = blk->next)
		{
			for (line = blk->lines; line; line = line->next)
			{
				string strTextPerLine;
				POINT ptFirstWord;
				ptFirstWord.x = line->words->xMin;
				ptFirstWord.y = line->words->yMin;
				for (word0 = line->words; word0; word0 = word0->next)
				{
					int fontSize = word0->fontSize-1;
					double r, g, b;
					word0->getColor(&r,&g,&b);
					COLORREF m_clColor = RGB(r*255,g*255,b*255);
					LPCTSTR lpFontName = word0->getFontName()?word0->getFontName()->getCString():"Arial";
					int bIsBold = word0->font->isBold();
					int bIsItalic = word0->font->isItalic();

					char szTmpFontName[1024];
					strcpy(szTmpFontName, lpFontName);
					strlwr(szTmpFontName);
					if(strstr(szTmpFontName,"bold"))
						bIsBold = TRUE;
					if(strstr(szTmpFontName,"italic"))
						bIsItalic = TRUE;
					char *lpSubFont = strchr(lpFontName, '+');
					if(lpSubFont)
						lpFontName = lpSubFont+1;
					char szFontName[1024];
					strcpy(szFontName, lpFontName);
					GString *substName = new GString(szFontName);
					DisplayFontParam* dfp = globalParams->getDisplayFont(substName);
					delete substName;
					if(dfp)
					{
						if(dfp->name && dfp->name->getLength())
							strcpy(szFontName, dfp->name->getCString());
					}
					ConvertPDFFontToWinFont(szFontName, sizeof(szFontName));
					int xPos = word0->xMin;
					int yPos = word0->yMin;
					int rColor = r*255;
					int gColor = g*255;
					int bColor = b*255;

					SFONTITEM item;
					memset(&item, 0, sizeof(SFONTITEM));
					item.rColor = rColor;
					item.gColor = gColor;
					item.bColor = bColor;
					strcpy(item.font.lfFaceName, szFontName);
					item.font.lfHeight = fontSize;
					item.font.lfWeight = bIsBold;
					item.font.lfItalic = bIsItalic;
					int nFontIndex = FindFont(aryFonts, item);
					if(bCollectFonts)
					{
						if(nFontIndex == -1)
							aryFonts.push_back(item);
						continue;
					}
					string strText;
					for (int i = 0; i < word0->len; ++i)
					{
						unsigned short nChar = word0->text[i]&0xffff;
						char buf[8];
						memset(buf, 0, sizeof(buf));
						int n = uMap->mapUnicode(nChar, buf, sizeof(buf));
						ReplaceHTMLCode(buf, n, strText);
					}
					if(g_nOneWord == 0)
					{
						if(CompareWordAttributes(word0, word0->next) == 0)
						{
							strTextPerLine += strText;
							if(word0->spaceAfter)
								strTextPerLine += " ";
							continue;
						}
						else
						{
							strTextPerLine += strText;
							strText = strTextPerLine;
							strTextPerLine = "";
							xPos = ptFirstWord.x;
							yPos = ptFirstWord.y;
							if(word0->next)
							{
								ptFirstWord.x = word0->next->xMin;
								ptFirstWord.y = word0->next->yMin;
							}
						}
					}
					{
						char szHREF1[2048] = {0};
						char szHREF2[20] = {0};
//						Catalog *lpCatalog = doc->getCatalog();
//						Page *lpPage = lpCatalog->getPage(curPage);
//						if(lpPage && lpPage->isCropped())
//						{
//							  PDFRectangle *lpMediaBox = lpPage->getMediaBox();
//							  PDFRectangle *lpCropBox = lpPage->getCropBox();
//						}
						double dbMediaHeight = doc->getPageMediaHeight(page);
						double dbCropHeight = doc->getPageCropHeight(page);
						double dbCenterPTX = xPos*72.0/resolution + fontSize/2;
						double dbCenterPTY = dbMediaHeight-yPos*72.0/resolution - fontSize/2;
						if(lpLinks)
						{
							LinkAction *lpLinkAction = lpLinks->find(dbCenterPTX, dbCenterPTY);
							if(lpLinkAction)
							{
								doAction(doc, page, lpLinkAction,szHREF1);
								strcpy(szHREF2, "</a>");
							}
						}
						char szHTMLText[4096] = {0};
						if(nFontIndex == -1)
						{
							sprintf(szHTMLText, "<div class=\"pos\" id=\"*%d:%d\" style=\"top:%d;left:%d\">"
								"%s<span id=\"*%d\" style=\"font-style:%s;font-weight:%s;font-size:%dpx;font-family:%s;"
								"color:#%02X%02X%02X;\">",
								g_ptLastPage.y+yPos, xPos,
								g_ptLastPage.y+yPos, xPos, szHREF1, fontSize, bIsItalic?"italic":"normal", bIsBold?"700":"normal", 
								fontSize, szFontName, rColor, gColor, bColor);
						}
						else
						{
							sprintf(szHTMLText, "<div class=\"pos\" id=\"*%d:%d\" style=\"top:%d;left:%d\">"
								"%s<span class=\"ft%d\" id=\"*%d\">",
								g_ptLastPage.y+yPos, xPos,
								g_ptLastPage.y+yPos, xPos, szHREF1, nFontIndex, fontSize);
						}
						fputs(szHTMLText, file);
						fputs(strText.c_str(), file);
						fprintf(file, "</span>%s</div>\n", szHREF2);
					}
				}
			}
		}
	}
	uMap->decRefCnt();
	return TRUE;
}
char *doAction(PDFDoc *doc, int page, LinkAction *action, char *lpszCommand)
{
	LinkActionKind kind;
	LinkDest *dest;
	GString *namedDest;
	char *s;
	GString *fileName, *fileName2;
	GString *cmd;
	GString *actionName;
	Object movieAnnot, obj1, obj2;
	int i;
	int topPageA = 1;
	
	switch (kind = action->getKind())
	{	
		// GoTo / GoToR action
	case actionGoTo:
	case actionGoToR:
		if (kind == actionGoTo)
		{
			dest = NULL;
			namedDest = NULL;
			if ((dest = ((LinkGoTo *)action)->getDest())) {
				dest = dest->copy();
			} else if ((namedDest = ((LinkGoTo *)action)->getNamedDest())) {
				namedDest = namedDest->copy();
			}
		} else {
			dest = NULL;
			namedDest = NULL;
			if ((dest = ((LinkGoToR *)action)->getDest())) {
				dest = dest->copy();
			} else if ((namedDest = ((LinkGoToR *)action)->getNamedDest())) {
				namedDest = namedDest->copy();
			}
			s = ((LinkGoToR *)action)->getFileName()->getCString();
			if(s && lpszCommand)
			{
				sprintf(lpszCommand, "<a href=\"%s\">", s);
				if (dest) {
					delete dest;
				}
				if (namedDest) {
					delete namedDest;
				}
				return lpszCommand;
			}
		}
		if (namedDest) {
			dest = doc->findDest(namedDest);
			delete namedDest;
		}
		if (dest) {
			if (dest->isPageRef()) {
				Ref pageRef;
				pageRef = dest->getPageRef();
				topPageA = doc->findPage(pageRef.num, pageRef.gen);
			} else {
				topPageA = dest->getPageNum();
			}
			if (topPageA <= 0 || topPageA > doc->getNumPages()) {
				topPageA = 1;
			}
			if(lpszCommand)
				sprintf(lpszCommand, "<a href=\"pg_%04d.htm\">", topPageA);
			delete dest;
		} else {
			if (kind == actionGoToR) {
				if(lpszCommand)
					sprintf(lpszCommand, "<a href=\"pg_%04d.htm\">", topPageA);
			}
		}
		break;
		
		// Launch action
	case actionLaunch:
		fileName = ((LinkLaunch *)action)->getFileName();
		s = fileName->getCString();
		if(s && lpszCommand)
			sprintf(lpszCommand, "<a href=\"%s\">", s);
		break;
		
		// URI action
	case actionURI:
		cmd = ((LinkURI *)action)->getURI();
		if(cmd && lpszCommand)
			sprintf(lpszCommand, "<a href=\"%s\">", cmd->getCString());
		break;
		
		// Named action
	case actionNamed:
		actionName = ((LinkNamed *)action)->getName();
		if (!actionName->cmp("NextPage")) {
//			gotoNextPage(1, gTrue);
		} else if (!actionName->cmp("PrevPage")) {
//			gotoPrevPage(1, gTrue, gFalse);
		} else if (!actionName->cmp("FirstPage")) {
//			if (topPage != 1) {
//				displayPage(1, zoom, rotate, gTrue, gTrue);
//			}
		} else if (!actionName->cmp("LastPage")) {
//			if (topPage != doc->getNumPages()) {
//				displayPage(doc->getNumPages(), zoom, rotate, gTrue, gTrue);
//			}
		} else if (!actionName->cmp("GoBack")) {
//			goBackward();
		} else if (!actionName->cmp("GoForward")) {
//			goForward();
		} else if (!actionName->cmp("Quit")) {
//			if (actionCbk) {
//				(*actionCbk)(actionCbkData, actionName->getCString());
//			}
		} else {
			error(-1, "Unknown named action: '%s'", actionName->getCString());
		}
		break;
		
		// Movie action
	case actionMovie:
		if (((LinkMovie *)action)->hasAnnotRef()) {
			doc->getXRef()->fetch(((LinkMovie *)action)->getAnnotRef()->num,
				((LinkMovie *)action)->getAnnotRef()->gen,
				&movieAnnot);
		} else {
			//~ need to use the correct page num here
			doc->getCatalog()->getPage(page)->getAnnots(&obj1);
			if (obj1.isArray()) {
				for (i = 0; i < obj1.arrayGetLength(); ++i) {
					if (obj1.arrayGet(i, &movieAnnot)->isDict()) {
						if (movieAnnot.dictLookup("Subtype", &obj2)->isName("Movie")) {
							obj2.free();
							break;
						}
						obj2.free();
					}
					movieAnnot.free();
				}
				obj1.free();
			}
		}
		if (movieAnnot.isDict()) {
			if (movieAnnot.dictLookup("Movie", &obj1)->isDict()) {
				if (obj1.dictLookup("F", &obj2)) {
					if ((fileName = LinkAction::getFileSpecName(&obj2))) {
						if (!isAbsolutePath(fileName->getCString())) {
							fileName2 = appendToPath(
								grabPath(doc->getFileName()->getCString()),
								fileName->getCString());
							delete fileName;
							fileName = fileName2;
						}
						if(fileName && lpszCommand)
							sprintf(lpszCommand, "<a href=\"%s\">", fileName);
						delete fileName;
					}
					obj2.free();
				}
				obj1.free();
			}
		}
		movieAnnot.free();
		break;
		
		// unknown action type
	case actionUnknown:
		error(-1, "Unknown link action type: '%s'",
			((LinkUnknown *)action)->getAction()->getCString());
		break;
  }
  return lpszCommand;
}

int WriteToHTMLByVeryPDF(PDFDoc *doc,LPCTSTR lpHtmlFile, int page, SplashBitmap* lpBitmap, TextOutputDev *lpTextFormater,
					  BOOL bDeletePictures,  int pages, int curPage)
{
	if(lpHtmlFile == NULL || lpBitmap == NULL)
		return 0;
	Links *lpLinks = NULL;
	if(!g_nOneHTMLFile)
		lpLinks = doc->getLinks(curPage);
#ifdef _DEBUG
	if(lpLinks)
	{
		for(int i = 0; i < lpLinks->getNumLinks(); i++)
		{
			Link *lpLink = lpLinks->getLink(i);
			if(lpLink == NULL)
				continue;
			LinkAction *lpLinkAction = lpLink->getAction();
			if(lpLinkAction == NULL)
				continue;
			double xa1, double ya1, double xa2, double ya2;
			lpLink->getRect(&xa1, &ya1, &xa2, &ya2);
			char szHREF1[1024] = {0};
			doAction(doc, page, lpLinkAction,szHREF1);
			strcat(szHREF1, "</a>");
			char szLinkInfo[1024] = {0};
			sprintf(szLinkInfo, "[%f,%f,%f,%f], %s\n", xa1, ya1, xa2, ya2, szHREF1);
			OutputDebugString(szLinkInfo);
		}
	}
#endif

	char szHTMLRoot[MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_PATH];
	char ext[_MAX_EXT];
	_splitpath(lpHtmlFile, drive, dir, fname, ext );
	_makepath(szHTMLRoot, drive, dir, fname, "");
	if(szHTMLRoot[strlen(szHTMLRoot)-1] != '\\')
		strcat(szHTMLRoot, "\\");
	char szImgName[MAX_PATH] = {0};
	char szImgBaseName[MAX_PATH] = {0};
	int nImgWidth = lpBitmap->getWidth();
	int nImgHeight = lpBitmap->getHeight();

	if(!bDeletePictures)
	{
		sprintf(szImgName, "%spg_%04d.pnm",szHTMLRoot, page);
		sprintf(szImgBaseName, "pg_%04d.jpg", page);
		lpBitmap->writePNMFile(szImgName);

		char szImgName2[MAX_PATH];
		_splitpath(szImgName, drive, dir, fname, ext );
		_makepath(szImgName2, drive, dir, fname,".jpg");
		char szCommandLine[1024];
		sprintf(szCommandLine, "imgconvert.exe \"%s\" \"%s\"", szImgName, szImgName2);
		system(szCommandLine);
		DeleteFile(szImgName);
	}
	FILE *m_pFile = NULL;
	char szHTMLFileName[MAX_PATH];
	if(g_nOneHTMLFile)
	{
		sprintf(szHTMLFileName, "%sindex.htm",szHTMLRoot);
		m_pFile = fopen(szHTMLFileName,"ab");
	}
	else
	{
		sprintf(szHTMLFileName, "%spg_%04d.htm",szHTMLRoot, page);
		m_pFile = fopen(szHTMLFileName,"wb");
	}
	if(m_pFile == NULL)
		return 0;
	_splitpath(szHTMLFileName, drive, dir, fname, ext );
	if(g_nNoUTF8Flag == FALSE)
		fputs("\xEF\xBB\xBF",m_pFile);
	fputs("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n<!-- saved from url=(0052)http://www.verypdf.com/ -->\n",m_pFile);
	fputs("<html>\n<head>\n",m_pFile);

	int nHTMLInfLength = 0;
	BOOL bHasTitle = FALSE;
	LPBYTE lpHTMLInfText = ReadHTMLInfo(nHTMLInfLength,bHasTitle);
	if(lpHTMLInfText != NULL && nHTMLInfLength > 0)
		fwrite(lpHTMLInfText, 1, nHTMLInfLength, m_pFile);
	if(!bHasTitle)
	{
		fprintf(m_pFile,"%s","<title>");
		fprintf(m_pFile,"%s",fname);
		fprintf(m_pFile,"%s","</title>\n");
	}
	if(lpHTMLInfText)
		free(lpHTMLInfText);
	lpHTMLInfText = NULL;
	fputs("\n",m_pFile);
	fputs("<META http-equiv=Content-Type content=\"text/html; charset=utf-8\">\n",m_pFile);
	fputs("<style>\n<!-- \nselect {font-size:12px;}\nA:link {text-decoration: none; color: blue}\n"
		"A:visited {text-decoration: none; color: purple}\nA:active {text-decoration: red}\n"
		"A:hover {text-decoration: underline; color:red}\n-->\n</style>\n",m_pFile);
	fputs("<script TYPE=\"text/javascript\"> \n<!-- hide \nfunction killerrors()\n{ \nreturn true; \n} \n"
		"window.onerror = killerrors; \n// --> \n</script>\n",m_pFile);
	fprintf(m_pFile,"%s","<style type=\"text/css\">\n<!--\n");
	//Write position class
	fputs(".pos {position:absolute; z-index: 0; left: 0px; top: 0px;}\n",m_pFile);

	if(!g_nOneHTMLFile)
		g_aryHTMLFonts.clear();
	for(int nFtIdx = 0; nFtIdx < g_aryHTMLFonts.size(); nFtIdx++)
	{
		SFONTITEM *lpFont = &g_aryHTMLFonts[nFtIdx];
		fprintf(m_pFile,".ft%d{font-style:%s;font-weight:%s;font-size:%dpx;font-family:%s;color:#%02X%02X%02X;}\n",
			nFtIdx, lpFont->font.lfItalic?"italic":"normal",
			lpFont->font.lfWeight?"700":"normal",
			lpFont->font.lfHeight, lpFont->font.lfFaceName,
			lpFont->rColor, lpFont->gColor, lpFont->bColor);
	}
	COLORREF m_clBackground = RGB(255,255,255);
	fprintf(m_pFile,"-->\n</style>\n</head>\n<body vlink=\"#FFFFFF\" link=\"#FFFFFF\" bgcolor=\"#%02x%02x%02x\">\n",
		GetRValue(m_clBackground),GetGValue(m_clBackground),GetBValue(m_clBackground));
	fputs("\n\
<script TYPE=\"text/javascript\">\n\
var currentpos,timer; \n\
function initialize() \n\
{ \n\
timer=setInterval(\"scrollwindow()\",10);\n\
} \n\
function sc(){\n\
clearInterval(timer); \n\
}\n\
function scrollwindow() \n\
{ \n\
currentpos=document.body.scrollTop; \n\
window.scroll(0,++currentpos); \n\
if (currentpos != document.body.scrollTop) \n\
sc();\n\
} \n\
document.onmousedown=sc\n\
document.ondblclick=initialize\n\
</script>\n",m_pFile);

	//<div style="position:absolute;top:0;left:0"><img width="359" height="362" src="f:\xuehenghengheng.htm-2_1.bmp"></div>
	//дͼͼ
	SIZE size;
	size.cx = nImgWidth;
	size.cy = nImgHeight;

	fputs("<nobr>\n",m_pFile);
	if(szImgBaseName[0])
	{
		CString m_strImage;
		m_strImage.Format("<div class=\"pos\" id=\"*%d:%d\" style=\"top:%d;left:%d\"><img name=\"*%d:%d\" width=\"%d\" height=\"%d\" src=\"%s\" ALT=\"\"></div>\n",
			g_ptLastPage.y, g_ptLastPage.x,
			g_ptLastPage.y, g_ptLastPage.x, size.cx,size.cy,size.cx,size.cy,szImgBaseName);
		fprintf(m_pFile,"%s",m_strImage);
	}

	if(g_nNoTextInHTMLBody == 0)
		ConvertTextBlocks(m_pFile, g_aryHTMLFonts, lpTextFormater, FALSE, lpLinks, doc, page, curPage);

	fputs("</nobr>\n",m_pFile);
	if(g_nOneHTMLFile == 0)
	{
		if(!g_nNoSEO)
		{
			fputs("<div class=\"pos\" id=\"*1:1\" style=\"top:1;left:1\">", m_pFile);
			if(g_szHomeURL[0] && strlen(g_szHomeURL) > 0)
				fprintf(m_pFile, "<a target=\"_blank\" href=\"%s\">Home</a> ",g_szHomeURL);
			fputs("<a target=\"_blank\" href=\"index.htm\">Index</a> ",m_pFile);
			CString strBookmarkFileName = szHTMLRoot;
			strBookmarkFileName += "bookmark.htm";
			if(GetFileAttributes(strBookmarkFileName) != -1)
				fputs("<a href=\"bookmark.htm\">Bookmark</a> ",m_pFile);
			fputs("<a href=\"allpgs.htm\">Pages</a> ",m_pFile);

			CString strTextFile = szHTMLRoot;
			strTextFile += "txtidx.htm";
			if(GetFileAttributes(strTextFile) != -1)
				fputs("<a href=\"txtidx.htm\">Text</a> ",m_pFile);
			fputs("</div>\n", m_pFile);

			//Create preview and next buttons
			fprintf(m_pFile, "<div class=\"pos\" id=\"*%d:0\" style=\"top:%d;left:%d\">",
				nImgHeight,nImgHeight,nImgWidth/2-50);
			if(curPage > 1)
				fprintf(m_pFile, "<a href=\"pg_%04d.htm\" title=\"Go to previous page\">Previous</a> ",curPage-1);
			if(curPage < pages)
				fprintf(m_pFile, "<a href=\"pg_%04d.htm\" title=\"Go to next page\">Next</a>\n",curPage+1);
			fputs("</div>\n",m_pFile);
				
			////////////////
			fprintf(m_pFile, "<div class=\"pos\" id=\"*%d:0\" style=\"top:%d;left:0\">"
				"<font size=\"1\" face=\"Verdana\">Pages: ",nImgHeight+20, nImgHeight+20);
			if(g_szHomeURL[0] && strlen(g_szHomeURL) > 0)
			{
				fprintf(m_pFile, "<a target=\"_blank\" href=\"%s\">Home</a> ",g_szHomeURL);
			}
			fputs("<a target=\"_blank\" href=\"index.htm\">Index</a> ",m_pFile);

			//Create an external html file
			CString strPgsName = "allpgs.htm";
			CString strAllPgs = szHTMLRoot;
			strAllPgs += strPgsName;
			if(GetFileAttributes(strAllPgs) == -1)
			{
				FILE *fileAllPgs = fopen(strAllPgs, "wb");
				if(fileAllPgs)
				{
					for(int pg = 1; pg <= pages; pg++)
					{
						fprintf(fileAllPgs, "<a href=\"pg_%04d.htm\">%d</a> ",pg,pg);
					}
					fclose(fileAllPgs);
				}
			}
			fprintf(m_pFile, "\n<span id=showImport></span>\n"
				"<IE:Download ID=\"oDownload\" STYLE=\"behavior:url(#default#download)\"/>\n"
				"<script>\n"
				"function onDownloadDone(downDate){\n"
				"showImport.innerHTML=downDate\n"
				"}\n"
				"oDownload.startDownload('%s',onDownloadDone)\n"
				"</script>\n",LPCTSTR(strPgsName));

			fputs("</font></div>\n",m_pFile);

			char szWatermarkFile[_MAX_PATH];
			GetModuleFileName(NULL,szWatermarkFile,_MAX_PATH);
			_splitpath(szWatermarkFile, drive, dir, fname, ext );
			_makepath(szWatermarkFile, drive, dir,"watermark",".htm");
			if(GetFileAttributes(szWatermarkFile) != -1)
			{
				int nWatermarkLength = 0;
				LPBYTE lpWatermarkText = LoadFileIntoMemory(szWatermarkFile, nWatermarkLength);
				if(lpWatermarkText != NULL && nWatermarkLength >= 0)
				{
					fwrite(lpWatermarkText, 1, nWatermarkLength, m_pFile);
					free(lpWatermarkText);
					lpWatermarkText = NULL;
				}
			}
		}

		fprintf(m_pFile,"<script TYPE=\"text/javascript\"> if(parent) if(parent.ltop)"
		"{var currentZoom = parent.ltop.currentZoom; if(currentZoom != undefined)"
		"{if(parent.ltop.isBrowser('Explorer', 0) == true)	document.body.style.zoom=currentZoom/100;"
		"else parent.ltop.MyNewZoomForFireFox(currentZoom);} parent.ltop.setgotopagestatus(%d);"
		"\nparent.ltop.document.zoomList.zoomSelected.selectedIndex = (currentZoom-50)/10;}"
		"\n</script>\n", page);
	}
	else 
	{
		g_ptLastPage.y += size.cy + 10;
	}
	fprintf(m_pFile,"%s","</body>\n</html>");
	fclose(m_pFile);
	return 1;
}
//////////////////////////////////////////////////////////////
//  getBookmark  ȡǩ
//    : szFileName -- ǩļƴŵ·
//          size -- szFileName length
//  Author: xueheng
//  Date  : 2002/07/10
//////////////////////////////////////////////////////////////
int readOutlinesTree(Catalog *lpCatalog, Object& outlinesDict,FILE* file, int& nesting);
int getBookmark(XRef* xref, Catalog *lpCatalog, char* szFileName,int size)
{
	if(xref == NULL || szFileName == NULL || size <= 0)
		return gFalse;
	//get Outlines from catalog dictionary
	Object catDict;
	Object obj, obj2;

	xref->getCatalog(&catDict);
	if (!catDict.isDict()) 
	{
		catDict.free();
		return gFalse;
	}

	int outlineCount = 0;
	{
		char path_buffer[_MAX_PATH];
		char drive[_MAX_DRIVE];
		char dir[_MAX_DIR];
		char fname[_MAX_FNAME];
		char ext[_MAX_EXT];
		GetModuleFileName(NULL,path_buffer,_MAX_PATH);
		_splitpath(path_buffer, drive, dir, fname, ext );
		_makepath( path_buffer, drive, dir,"outlines",".txt");
		unlink(path_buffer);

		Object outlinesDict;
		if (catDict.dictLookup("Outlines", &outlinesDict)->isDict())
		{
			outlinesDict.dictLookup("Count", &obj);
			if (obj.isInt())
				outlineCount = obj.getInt();
			obj.free();
			if(outlineCount > 0)
			{
				int nesting = -1;
				FILE* file = fopen(path_buffer,"w");
				readOutlinesTree(lpCatalog, outlinesDict,file, nesting);
				fclose(file);
			}
		}
		outlinesDict.free();
		if(strlen(path_buffer) < size)
			strcpy(szFileName,path_buffer);
		else
			strncpy(szFileName,path_buffer,size);
	}
	catDict.free();
	if(outlineCount > 0)
		return gTrue;
	return gFalse;
}
//////////////////////////////////////////////////////////////
//
//  readOutlinesTreeȡĿ¼
//  outlinesDict
//        Outline's Root(ٸ)
//  Author: xueheng
//  Date  : 2002/04/21
//////////////////////////////////////////////////////////////
int readOutlinesTree(Catalog *lpCatalog, Object& outlinesDict,FILE* file, int& nesting)
{
	Object firstOutlinesDist,lastOutlinesDist,obj;
	
	outlinesDict.dictLookup("First", &firstOutlinesDist);
	outlinesDict.dictLookup("Last", &lastOutlinesDist);
	if(!firstOutlinesDist.isDict() || !lastOutlinesDist.isDict())
	{
		firstOutlinesDist.free();
		lastOutlinesDist.free();
		return 1;
	}
	//¼Ƕ׵Ĳ
	nesting++;
	do{
		//Title
		firstOutlinesDist.dictLookup("Title", &obj);
		if (obj.isString() )
		{
			if(file)
			{
				for(int i = 0; i < nesting; i++)
					fputc('\t',file);
				char *pTitle = obj.getString()->getCString();
				int m_iTitleLen = obj.getString()->getLength();
				if(pTitle && pTitle[0])
				{
					if(m_iTitleLen > 2 && (BYTE)(pTitle[0]) == 0xFE && (BYTE)(pTitle[1]) == 0xFF)
					{
						char *pTitle2 = new char[m_iTitleLen*2];
						memset(pTitle2,0,m_iTitleLen*2);
						pTitle += 2;
						m_iTitleLen -= 2;
						m_iTitleLen /= 2;
						unsigned short *pTitleWord = (unsigned short *)pTitle;
						for(int ii = 0; ii < m_iTitleLen; ii++)
						{
							pTitle2[ii] = HIBYTE(pTitleWord[ii]);
							if(pTitle2[ii] == '"')
								pTitle2[ii] = 0x20;
						}
						fprintf(file,"%s",pTitle2);
						delete []pTitle2;
					}
					else
					{
						for(int ii = 0; ii < m_iTitleLen; ii++)
						{
							if((BYTE)pTitle[ii] == 0x8D)
								pTitle[ii] = '"';
							else if((BYTE)pTitle[ii] == 0x8E)
								pTitle[ii] = '"';
						}
						fprintf(file,"%s",pTitle);
					}
				}
				else
					fprintf(file,"%s"," ");
			}
		}
		obj.free();
		//Dest
		firstOutlinesDist.dictLookup("Dest", &obj);
		{
			LinkDest *dest = NULL;
			int page = 0;
			if (obj.isString() )
			{//Destͣ/Dest (G3.127)
				dest = lpCatalog->findDest(obj.getString());
				//TRACE("\t%s",obj.getString()->getCString());
			}
			else if (obj.isArray() )
			{//Destͣ/Dest[8 0 R/XYZ null null 0]
				dest = new LinkDest(obj.getArray());
			}
			else if (obj.isDict()) 
			{
				Object obj2;
				if (obj.dictLookup("D", &obj2)->isArray())
					dest = new LinkDest(obj2.getArray());
				else
					error(-1, "Bad named destination value");
				obj2.free();
			}
			else if(obj.isNull())
			{
				Object obj2,obj3;
				if (firstOutlinesDist.dictLookup("A", &obj2)->isDict())
				{
					if (obj2.dictLookup("D", &obj3)->isArray())
						dest = new LinkDest(obj3.getArray());
				}
				obj2.free();
				obj3.free();
			}
			else
			{
				error(-1, "Bad named destination value");
			}
			if (dest)
			{ 
				if (dest->isPageRef())
				{
					Ref pageref = dest->getPageRef();
					page = lpCatalog->findPage(pageref.num,pageref.gen);
				}
				else  
					page = dest->getPageNum();
				if(file)
				{
					fprintf(file,"<>,%d,%d,%d,%d,%d,%d,%d,%d,%d\n",
						page,dest->getLeft(),dest->getTop(),
						dest->getRight(),dest->getBottom(),
						dest->getZoom(),dest->getChangeLeft(),
						dest->getChangeTop(),
						dest->getChangeZoom()
						);
				}
				delete dest;
			}
			else
			{
				if(file)
					fputc('\n',file);
			}
		}
		obj.free();
		//ǶײѯOutlinesbegin
		{
			int dictLength = firstOutlinesDist.dictGetLength();
			BOOL firstIn = FALSE,lastIn = FALSE;
			for(int i = 0; i < dictLength; i++)
			{
				if(!firstIn && strcmp("First",firstOutlinesDist.dictGetKey(i)) == 0)
					firstIn = TRUE;
				if(!lastIn && strcmp("Last",firstOutlinesDist.dictGetKey(i)) == 0)
					lastIn = TRUE;
				if(firstIn && lastIn)
					break;
			}
			if(firstIn && lastIn)
				readOutlinesTree(lpCatalog, firstOutlinesDist, file, nesting);
		}
		//ǶײѯOutlinesend
		firstOutlinesDist.dictLookup("Next", &obj);
		if(!obj.isDict())
		{
			obj.free();
			break;
		}
		firstOutlinesDist.free();
		obj.copy(&firstOutlinesDist);
		obj.free();
	}while(firstOutlinesDist.isDict());

	//¼Ƕ׵Ĳ
	nesting--;

	firstOutlinesDist.free();
	lastOutlinesDist.free();
	return 0;
}
